// Generated by the protocol buffer compiler.  DO NOT EDIT!
// source: commonmodule/commonmodule.proto

package openfmb.commonmodule;

/**
 * <pre>
 * Generic reading message information
 * </pre>
 *
 * Protobuf type {@code commonmodule.ReadingMessageInfo}
 */
public final class ReadingMessageInfo extends
    com.google.protobuf.GeneratedMessageV3 implements
    // @@protoc_insertion_point(message_implements:commonmodule.ReadingMessageInfo)
    ReadingMessageInfoOrBuilder {
private static final long serialVersionUID = 0L;
  // Use ReadingMessageInfo.newBuilder() to construct.
  private ReadingMessageInfo(com.google.protobuf.GeneratedMessageV3.Builder<?> builder) {
    super(builder);
  }
  private ReadingMessageInfo() {
  }

  @java.lang.Override
  @SuppressWarnings({"unused"})
  protected java.lang.Object newInstance(
      UnusedPrivateParameter unused) {
    return new ReadingMessageInfo();
  }

  public static final com.google.protobuf.Descriptors.Descriptor
      getDescriptor() {
    return openfmb.commonmodule.Commonmodule.internal_static_commonmodule_ReadingMessageInfo_descriptor;
  }

  @java.lang.Override
  protected com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
      internalGetFieldAccessorTable() {
    return openfmb.commonmodule.Commonmodule.internal_static_commonmodule_ReadingMessageInfo_fieldAccessorTable
        .ensureFieldAccessorsInitialized(
            openfmb.commonmodule.ReadingMessageInfo.class, openfmb.commonmodule.ReadingMessageInfo.Builder.class);
  }

  public static final int MESSAGEINFO_FIELD_NUMBER = 1;
  private openfmb.commonmodule.MessageInfo messageInfo_;
  /**
   * <pre>
   * UML inherited base object
   * </pre>
   *
   * <code>.commonmodule.MessageInfo messageInfo = 1 [(.uml.option_parent_message) = true];</code>
   * @return Whether the messageInfo field is set.
   */
  @java.lang.Override
  public boolean hasMessageInfo() {
    return messageInfo_ != null;
  }
  /**
   * <pre>
   * UML inherited base object
   * </pre>
   *
   * <code>.commonmodule.MessageInfo messageInfo = 1 [(.uml.option_parent_message) = true];</code>
   * @return The messageInfo.
   */
  @java.lang.Override
  public openfmb.commonmodule.MessageInfo getMessageInfo() {
    return messageInfo_ == null ? openfmb.commonmodule.MessageInfo.getDefaultInstance() : messageInfo_;
  }
  /**
   * <pre>
   * UML inherited base object
   * </pre>
   *
   * <code>.commonmodule.MessageInfo messageInfo = 1 [(.uml.option_parent_message) = true];</code>
   */
  @java.lang.Override
  public openfmb.commonmodule.MessageInfoOrBuilder getMessageInfoOrBuilder() {
    return messageInfo_ == null ? openfmb.commonmodule.MessageInfo.getDefaultInstance() : messageInfo_;
  }

  private byte memoizedIsInitialized = -1;
  @java.lang.Override
  public final boolean isInitialized() {
    byte isInitialized = memoizedIsInitialized;
    if (isInitialized == 1) return true;
    if (isInitialized == 0) return false;

    memoizedIsInitialized = 1;
    return true;
  }

  @java.lang.Override
  public void writeTo(com.google.protobuf.CodedOutputStream output)
                      throws java.io.IOException {
    if (messageInfo_ != null) {
      output.writeMessage(1, getMessageInfo());
    }
    getUnknownFields().writeTo(output);
  }

  @java.lang.Override
  public int getSerializedSize() {
    int size = memoizedSize;
    if (size != -1) return size;

    size = 0;
    if (messageInfo_ != null) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(1, getMessageInfo());
    }
    size += getUnknownFields().getSerializedSize();
    memoizedSize = size;
    return size;
  }

  @java.lang.Override
  public boolean equals(final java.lang.Object obj) {
    if (obj == this) {
     return true;
    }
    if (!(obj instanceof openfmb.commonmodule.ReadingMessageInfo)) {
      return super.equals(obj);
    }
    openfmb.commonmodule.ReadingMessageInfo other = (openfmb.commonmodule.ReadingMessageInfo) obj;

    if (hasMessageInfo() != other.hasMessageInfo()) return false;
    if (hasMessageInfo()) {
      if (!getMessageInfo()
          .equals(other.getMessageInfo())) return false;
    }
    if (!getUnknownFields().equals(other.getUnknownFields())) return false;
    return true;
  }

  @java.lang.Override
  public int hashCode() {
    if (memoizedHashCode != 0) {
      return memoizedHashCode;
    }
    int hash = 41;
    hash = (19 * hash) + getDescriptor().hashCode();
    if (hasMessageInfo()) {
      hash = (37 * hash) + MESSAGEINFO_FIELD_NUMBER;
      hash = (53 * hash) + getMessageInfo().hashCode();
    }
    hash = (29 * hash) + getUnknownFields().hashCode();
    memoizedHashCode = hash;
    return hash;
  }

  public static openfmb.commonmodule.ReadingMessageInfo parseFrom(
      java.nio.ByteBuffer data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static openfmb.commonmodule.ReadingMessageInfo parseFrom(
      java.nio.ByteBuffer data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static openfmb.commonmodule.ReadingMessageInfo parseFrom(
      com.google.protobuf.ByteString data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static openfmb.commonmodule.ReadingMessageInfo parseFrom(
      com.google.protobuf.ByteString data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static openfmb.commonmodule.ReadingMessageInfo parseFrom(byte[] data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static openfmb.commonmodule.ReadingMessageInfo parseFrom(
      byte[] data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static openfmb.commonmodule.ReadingMessageInfo parseFrom(java.io.InputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input);
  }
  public static openfmb.commonmodule.ReadingMessageInfo parseFrom(
      java.io.InputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input, extensionRegistry);
  }
  public static openfmb.commonmodule.ReadingMessageInfo parseDelimitedFrom(java.io.InputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseDelimitedWithIOException(PARSER, input);
  }
  public static openfmb.commonmodule.ReadingMessageInfo parseDelimitedFrom(
      java.io.InputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseDelimitedWithIOException(PARSER, input, extensionRegistry);
  }
  public static openfmb.commonmodule.ReadingMessageInfo parseFrom(
      com.google.protobuf.CodedInputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input);
  }
  public static openfmb.commonmodule.ReadingMessageInfo parseFrom(
      com.google.protobuf.CodedInputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input, extensionRegistry);
  }

  @java.lang.Override
  public Builder newBuilderForType() { return newBuilder(); }
  public static Builder newBuilder() {
    return DEFAULT_INSTANCE.toBuilder();
  }
  public static Builder newBuilder(openfmb.commonmodule.ReadingMessageInfo prototype) {
    return DEFAULT_INSTANCE.toBuilder().mergeFrom(prototype);
  }
  @java.lang.Override
  public Builder toBuilder() {
    return this == DEFAULT_INSTANCE
        ? new Builder() : new Builder().mergeFrom(this);
  }

  @java.lang.Override
  protected Builder newBuilderForType(
      com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
    Builder builder = new Builder(parent);
    return builder;
  }
  /**
   * <pre>
   * Generic reading message information
   * </pre>
   *
   * Protobuf type {@code commonmodule.ReadingMessageInfo}
   */
  public static final class Builder extends
      com.google.protobuf.GeneratedMessageV3.Builder<Builder> implements
      // @@protoc_insertion_point(builder_implements:commonmodule.ReadingMessageInfo)
      openfmb.commonmodule.ReadingMessageInfoOrBuilder {
    public static final com.google.protobuf.Descriptors.Descriptor
        getDescriptor() {
      return openfmb.commonmodule.Commonmodule.internal_static_commonmodule_ReadingMessageInfo_descriptor;
    }

    @java.lang.Override
    protected com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
        internalGetFieldAccessorTable() {
      return openfmb.commonmodule.Commonmodule.internal_static_commonmodule_ReadingMessageInfo_fieldAccessorTable
          .ensureFieldAccessorsInitialized(
              openfmb.commonmodule.ReadingMessageInfo.class, openfmb.commonmodule.ReadingMessageInfo.Builder.class);
    }

    // Construct using openfmb.commonmodule.ReadingMessageInfo.newBuilder()
    private Builder() {

    }

    private Builder(
        com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
      super(parent);

    }
    @java.lang.Override
    public Builder clear() {
      super.clear();
      bitField0_ = 0;
      messageInfo_ = null;
      if (messageInfoBuilder_ != null) {
        messageInfoBuilder_.dispose();
        messageInfoBuilder_ = null;
      }
      return this;
    }

    @java.lang.Override
    public com.google.protobuf.Descriptors.Descriptor
        getDescriptorForType() {
      return openfmb.commonmodule.Commonmodule.internal_static_commonmodule_ReadingMessageInfo_descriptor;
    }

    @java.lang.Override
    public openfmb.commonmodule.ReadingMessageInfo getDefaultInstanceForType() {
      return openfmb.commonmodule.ReadingMessageInfo.getDefaultInstance();
    }

    @java.lang.Override
    public openfmb.commonmodule.ReadingMessageInfo build() {
      openfmb.commonmodule.ReadingMessageInfo result = buildPartial();
      if (!result.isInitialized()) {
        throw newUninitializedMessageException(result);
      }
      return result;
    }

    @java.lang.Override
    public openfmb.commonmodule.ReadingMessageInfo buildPartial() {
      openfmb.commonmodule.ReadingMessageInfo result = new openfmb.commonmodule.ReadingMessageInfo(this);
      if (bitField0_ != 0) { buildPartial0(result); }
      onBuilt();
      return result;
    }

    private void buildPartial0(openfmb.commonmodule.ReadingMessageInfo result) {
      int from_bitField0_ = bitField0_;
      if (((from_bitField0_ & 0x00000001) != 0)) {
        result.messageInfo_ = messageInfoBuilder_ == null
            ? messageInfo_
            : messageInfoBuilder_.build();
      }
    }

    @java.lang.Override
    public Builder mergeFrom(com.google.protobuf.Message other) {
      if (other instanceof openfmb.commonmodule.ReadingMessageInfo) {
        return mergeFrom((openfmb.commonmodule.ReadingMessageInfo)other);
      } else {
        super.mergeFrom(other);
        return this;
      }
    }

    public Builder mergeFrom(openfmb.commonmodule.ReadingMessageInfo other) {
      if (other == openfmb.commonmodule.ReadingMessageInfo.getDefaultInstance()) return this;
      if (other.hasMessageInfo()) {
        mergeMessageInfo(other.getMessageInfo());
      }
      this.mergeUnknownFields(other.getUnknownFields());
      onChanged();
      return this;
    }

    @java.lang.Override
    public final boolean isInitialized() {
      return true;
    }

    @java.lang.Override
    public Builder mergeFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      if (extensionRegistry == null) {
        throw new java.lang.NullPointerException();
      }
      try {
        boolean done = false;
        while (!done) {
          int tag = input.readTag();
          switch (tag) {
            case 0:
              done = true;
              break;
            case 10: {
              input.readMessage(
                  getMessageInfoFieldBuilder().getBuilder(),
                  extensionRegistry);
              bitField0_ |= 0x00000001;
              break;
            } // case 10
            default: {
              if (!super.parseUnknownField(input, extensionRegistry, tag)) {
                done = true; // was an endgroup tag
              }
              break;
            } // default:
          } // switch (tag)
        } // while (!done)
      } catch (com.google.protobuf.InvalidProtocolBufferException e) {
        throw e.unwrapIOException();
      } finally {
        onChanged();
      } // finally
      return this;
    }
    private int bitField0_;

    private openfmb.commonmodule.MessageInfo messageInfo_;
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.commonmodule.MessageInfo, openfmb.commonmodule.MessageInfo.Builder, openfmb.commonmodule.MessageInfoOrBuilder> messageInfoBuilder_;
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.MessageInfo messageInfo = 1 [(.uml.option_parent_message) = true];</code>
     * @return Whether the messageInfo field is set.
     */
    public boolean hasMessageInfo() {
      return ((bitField0_ & 0x00000001) != 0);
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.MessageInfo messageInfo = 1 [(.uml.option_parent_message) = true];</code>
     * @return The messageInfo.
     */
    public openfmb.commonmodule.MessageInfo getMessageInfo() {
      if (messageInfoBuilder_ == null) {
        return messageInfo_ == null ? openfmb.commonmodule.MessageInfo.getDefaultInstance() : messageInfo_;
      } else {
        return messageInfoBuilder_.getMessage();
      }
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.MessageInfo messageInfo = 1 [(.uml.option_parent_message) = true];</code>
     */
    public Builder setMessageInfo(openfmb.commonmodule.MessageInfo value) {
      if (messageInfoBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        messageInfo_ = value;
      } else {
        messageInfoBuilder_.setMessage(value);
      }
      bitField0_ |= 0x00000001;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.MessageInfo messageInfo = 1 [(.uml.option_parent_message) = true];</code>
     */
    public Builder setMessageInfo(
        openfmb.commonmodule.MessageInfo.Builder builderForValue) {
      if (messageInfoBuilder_ == null) {
        messageInfo_ = builderForValue.build();
      } else {
        messageInfoBuilder_.setMessage(builderForValue.build());
      }
      bitField0_ |= 0x00000001;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.MessageInfo messageInfo = 1 [(.uml.option_parent_message) = true];</code>
     */
    public Builder mergeMessageInfo(openfmb.commonmodule.MessageInfo value) {
      if (messageInfoBuilder_ == null) {
        if (((bitField0_ & 0x00000001) != 0) &&
          messageInfo_ != null &&
          messageInfo_ != openfmb.commonmodule.MessageInfo.getDefaultInstance()) {
          getMessageInfoBuilder().mergeFrom(value);
        } else {
          messageInfo_ = value;
        }
      } else {
        messageInfoBuilder_.mergeFrom(value);
      }
      bitField0_ |= 0x00000001;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.MessageInfo messageInfo = 1 [(.uml.option_parent_message) = true];</code>
     */
    public Builder clearMessageInfo() {
      bitField0_ = (bitField0_ & ~0x00000001);
      messageInfo_ = null;
      if (messageInfoBuilder_ != null) {
        messageInfoBuilder_.dispose();
        messageInfoBuilder_ = null;
      }
      onChanged();
      return this;
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.MessageInfo messageInfo = 1 [(.uml.option_parent_message) = true];</code>
     */
    public openfmb.commonmodule.MessageInfo.Builder getMessageInfoBuilder() {
      bitField0_ |= 0x00000001;
      onChanged();
      return getMessageInfoFieldBuilder().getBuilder();
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.MessageInfo messageInfo = 1 [(.uml.option_parent_message) = true];</code>
     */
    public openfmb.commonmodule.MessageInfoOrBuilder getMessageInfoOrBuilder() {
      if (messageInfoBuilder_ != null) {
        return messageInfoBuilder_.getMessageOrBuilder();
      } else {
        return messageInfo_ == null ?
            openfmb.commonmodule.MessageInfo.getDefaultInstance() : messageInfo_;
      }
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.MessageInfo messageInfo = 1 [(.uml.option_parent_message) = true];</code>
     */
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.commonmodule.MessageInfo, openfmb.commonmodule.MessageInfo.Builder, openfmb.commonmodule.MessageInfoOrBuilder> 
        getMessageInfoFieldBuilder() {
      if (messageInfoBuilder_ == null) {
        messageInfoBuilder_ = new com.google.protobuf.SingleFieldBuilderV3<
            openfmb.commonmodule.MessageInfo, openfmb.commonmodule.MessageInfo.Builder, openfmb.commonmodule.MessageInfoOrBuilder>(
                getMessageInfo(),
                getParentForChildren(),
                isClean());
        messageInfo_ = null;
      }
      return messageInfoBuilder_;
    }
    @java.lang.Override
    public final Builder setUnknownFields(
        final com.google.protobuf.UnknownFieldSet unknownFields) {
      return super.setUnknownFields(unknownFields);
    }

    @java.lang.Override
    public final Builder mergeUnknownFields(
        final com.google.protobuf.UnknownFieldSet unknownFields) {
      return super.mergeUnknownFields(unknownFields);
    }


    // @@protoc_insertion_point(builder_scope:commonmodule.ReadingMessageInfo)
  }

  // @@protoc_insertion_point(class_scope:commonmodule.ReadingMessageInfo)
  private static final openfmb.commonmodule.ReadingMessageInfo DEFAULT_INSTANCE;
  static {
    DEFAULT_INSTANCE = new openfmb.commonmodule.ReadingMessageInfo();
  }

  public static openfmb.commonmodule.ReadingMessageInfo getDefaultInstance() {
    return DEFAULT_INSTANCE;
  }

  private static final com.google.protobuf.Parser<ReadingMessageInfo>
      PARSER = new com.google.protobuf.AbstractParser<ReadingMessageInfo>() {
    @java.lang.Override
    public ReadingMessageInfo parsePartialFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      Builder builder = newBuilder();
      try {
        builder.mergeFrom(input, extensionRegistry);
      } catch (com.google.protobuf.InvalidProtocolBufferException e) {
        throw e.setUnfinishedMessage(builder.buildPartial());
      } catch (com.google.protobuf.UninitializedMessageException e) {
        throw e.asInvalidProtocolBufferException().setUnfinishedMessage(builder.buildPartial());
      } catch (java.io.IOException e) {
        throw new com.google.protobuf.InvalidProtocolBufferException(e)
            .setUnfinishedMessage(builder.buildPartial());
      }
      return builder.buildPartial();
    }
  };

  public static com.google.protobuf.Parser<ReadingMessageInfo> parser() {
    return PARSER;
  }

  @java.lang.Override
  public com.google.protobuf.Parser<ReadingMessageInfo> getParserForType() {
    return PARSER;
  }

  @java.lang.Override
  public openfmb.commonmodule.ReadingMessageInfo getDefaultInstanceForType() {
    return DEFAULT_INSTANCE;
  }

}

